#include <stdio.h>
#include <stdlib.h>

  /* Racuna prikaz broja n! u zadanoj bazi (kao polje znamenki)
     za sve brojeve n <= n_max.
     Aritmeticki gledano, radi korektno ako je n * (baza - 1)
     egzaktno prikaziv u tipu integer. Broj n NE mora biti
     jednoznamenkast u zadanoj bazi!
     Ako je polje za znamenke prekratko - ispisuje poruku.
  */

#define MAX_DEG 100

int main(void)
{
    const int baza = 10, n_max = 50;
    int i, deg, n, carry, temp;
    int fact[MAX_DEG + 1];

        /* Inicijalizacija polja znamenki za n = 1 (n! = 1).
           deg = najvisa potencija baze u n! */

    deg = 0;
    fact[deg] = 1;

        /* Petlja za n do n_max. */

    for (n = 2; n <= n_max; ++n) {

            /* Mnozenje fact = fact * n; (po znamenkama u polju). */

        carry = 0;

        for (i = 0; i <= deg; ++i) {
            temp = fact[i] * n + carry;
            fact[i] = temp % baza;
            carry = temp / baza;
        }

            /* Dozvoljeno je da carry ima vise od jedne znamenke! */

        while ( carry > 0 ) {
            deg = deg + 1;
            if (deg > MAX_DEG) {
                printf(" Broj ima vise od %d znamenki!\n", MAX_DEG);
                exit(1);
            }
            fact[deg] = carry %baza;
            carry = carry / baza;
        }

            /* Ispis znamenki od n! */

        printf(" %2d! = ", n);
        for (i = deg; i >= 0; --i)
            printf("%1d", fact[i]);
        printf("\n");

    }

    return 0;
}
