  /* Zadatak:
       Ispisati tablicu prostih brojeva do 100000.
  */

  /* Koristimo trecu (najbrzu) varijantu funkcije za proste brojeve:
       - test djelitelja 2, a zatim samo neparnih do (int) sqrt(n).
     Sve petlje po djeliteljima su for petlje!

     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).
  */

#include <stdio.h>
#include <math.h>

int prost_3(int n)
{
        /* Prvo testira parnost (djelitelj 2), a onda testira sve
           neparne djelitelje od 2 do max_d = (int) sqrt(n). */

    int d;        /* Potencijalni djelitelj. */
    int max_d;    /* Maksimalni potencijalni djelitelj. */

        /* Brojevi <= 1 nisu prosti (ignoriramo <= 0). */
    if (n <= 1) return 0;


        /* Testiraj parnost broja. Ako je paran, samo 2 je prost. */
    if (n % 2 == 0) return (n == 2);

        /* Najveci djelitelj kojeg treba provjeriti je
             max_d = (int) sqrt(n).
           Naime, ako n nije prost, onda ima dva netrivijalna djelitelja,
           a manji od njih je najvise jednak max_d. Ako takav djelitelj od n
           ne postoji, onda je n prost. */
        /* Napomena: Zaokruzivanje sqrt(n) na donje cijelo je korektno
           na cijelom tipu za n, tj. ne moza se dogoditi da dobijemo za
           jedan premalo. Posebno, za brojeve n koji su potpun kvadrat,
           uvijek dobijemo korektan cjelobrojni korijen. */
    max_d = (int) sqrt(n);

        /* Petlja po mogucim neparnim djeliteljima od n od 3 do max_d. */
    for (d = 3; d <= max_d; d += 2)
        if (n % d == 0) return 0;    /* Nije prost. */

    return 1;
}


    /* Tablica prostih brojeva do 100000.
       Svaki prosti broj pise u novom redu. */

int main(void)
{
    int n, max_p = 100000;

    printf(" Tablica prostih brojeva do %d\n", max_p);

        /* Broj 2, kao jedini paran prost broj. */
    printf(" %6d\n", 2);

        /* Dalje idemo po neparnim brojevima, pocev od 3. */
    for (n = 3; n <= max_p; n += 2)
        if (prost_3(n))
            printf(" %6d\n", n);

    return 0;
}
