#include <stdio.h>
#include <stdlib.h>

  /* Obicno potenciranje:
       Inicijalizacija za n = 0, ima jedno mnozenje viska.
  */

/****************************************************************************/

    /* Obicno potenciranje x^n. */

    /* Pretpostavka (bez provjere): n >= 0 i x != 0. */

    /* Rezultat se inicijalizira na 1, sto je korektno za n = 0.
       Za n > 0, prvo mnozenje je 1 * x, sto se moze izbjeci.
       Slozenost: n mnozenja.
    */

double pow_mul(double x, int n)
{
    double pot = 1.0;
    int i;

        /* Potenciranje mnozenjem. */

    for (i = 1; i <= n; ++i)
        pot *= x;

    return pot;
}

    /* Cjelobrojno potenciranje x^n.
       Koristi funkciju za x^abs(n). */

double int_pow(double x, int n)
{
    double pot;
    int neg;

        /* Provjera x = 0. */
    if (x == 0.0) return 0.0;

        /* Zapamti predznak od n. */
    neg = n < 0;
    n = abs(n);

        /* Potenciranje mnozenjem. */
    pot = pow_mul(x, n);

    if (neg) pot = 1.0 / pot;
    return pot;
}

int main(void)
{
    double x;
    int n;

    x = 2.0;
    for (n = 0; n <= 16; ++n)
        printf(" Potencija %3.1f na %2d = %7.1f\n",
                 x, n, int_pow(x, n) );

    n = 1000000000;     /* n = 10^9 */
    x = 1.000000001;    /* x = 1 + 1.0/n */

    printf(" Potencija %11.9f na %2d = %11.9f\n",
           x, n, int_pow(x, n) );

    return 0;
}
